//+------------------------------------------------------------------+
//| This MQL was created by Alfredo Cerbito Bana                     |
//|                http://kieruvel.blog.com/                         |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Alfredo Cerbito Bana"
#property link      "http://www.kieruvel.blog.com/"

extern int MagicNumber = 23456;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 0.01;
extern int Slippage = 3;
extern bool UseStopLoss = False;
extern int StopLoss = 30;
extern bool UseTakeProfit = True;
extern int TakeProfit = 500;
extern bool UseTrailingStop = True;
extern int TrailingStop = 250;

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+


double M9_1 = iMA(NULL, PERIOD_M1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_2 = iMA(NULL, PERIOD_M1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M9_3 = iMA(NULL, PERIOD_M5, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_4 = iMA(NULL, PERIOD_M5, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M9_5 = iMA(NULL, PERIOD_M15, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_6 = iMA(NULL, PERIOD_M15, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M9_7 = iMA(NULL, PERIOD_M30, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_8 = iMA(NULL, PERIOD_M30, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M9_9 = iMA(NULL, PERIOD_H1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_10 = iMA(NULL, PERIOD_H1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M9_11 = iMA(NULL, PERIOD_D1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M9_12 = iMA(NULL, PERIOD_D1, 9, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_1 = iMA(NULL, PERIOD_M1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_2 = iMA(NULL, PERIOD_M1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_3 = iMA(NULL, PERIOD_M5, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_4 = iMA(NULL, PERIOD_M5, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_5 = iMA(NULL, PERIOD_M15, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_6 = iMA(NULL, PERIOD_M15, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_7 = iMA(NULL, PERIOD_M30, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_8 = iMA(NULL, PERIOD_M30, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_9 = iMA(NULL, PERIOD_H1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_10 = iMA(NULL, PERIOD_H1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double M18_11 = iMA(NULL, PERIOD_D1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
double M18_12 = iMA(NULL, PERIOD_D1, 18, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double ADX_1 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 0);
double ADX_2 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 1);
double ADX_3 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 0);
double ADX_4 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 1);
double ADX_5 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_MAIN, Current + 0);
double ADX_6 = iADX(NULL, PERIOD_D1, 14, PRICE_CLOSE, MODE_MAIN, Current + 1);
double ADX_7 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_MAIN, Current + 0);
double ADX_8 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_MAIN, Current + 1);
double ADX_9 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 0);
double ADX_10 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 1);
double ADX_11 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 0);
double ADX_12 = iADX(NULL, PERIOD_H1, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 1);



   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

           

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

                      

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (M9_1 > M9_2 && M9_3 > M9_4 && M9_5 > M9_6 && M9_7 > M9_8 && M9_9 > M9_10 && M9_11 > M9_12 && M18_1 > M18_2 && M18_3 > M18_4 && M18_5 > M18_6 && M18_7 > M18_8 && M18_9 == M18_10 && M18_11 > M18_12 && ADX_1 > ADX_2 && ADX_3 < ADX_4 && ADX_5 > ADX_6 && ADX_7 > ADX_8 && ADX_9 > ADX_10 && ADX_11 < ADX_12) Order = SIGNAL_BUY;

  if (M9_1 < M9_2 && M9_3 < M9_4 && M9_5 < M9_6 && M9_7 < M9_8 && M9_9 < M9_10 && M9_11 < M9_12 && M18_1 < M18_2 && M18_3 < M18_4 && M18_5 < M18_6 && M18_7 < M18_8 && M18_9 == M18_10 && M18_11 < M18_12 && ADX_1 < ADX_2 && ADX_3 > ADX_4 && ADX_5 > ADX_6 && ADX_7 > ADX_8 && ADX_9 < ADX_10 && ADX_11 > ADX_12) Order = SIGNAL_SELL;


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+